// -*- C++ -*-

/***************************************************************************
                          configdialog.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIGDIALOG_H
#define CONFIGDIALOG_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

//
// Qt
//

#include <qdict.h>

#include <kdialogbase.h>

class QFrame;
class QBoxLayout;
class QCheckBox;

//
// App
//

class KapitalistApp;



// forward declarations
class ConfigTheme;
class ConfigAppearance;

/**
 * TODO
 */
class ConfigDialog : public KDialogBase
{
  Q_OBJECT

public:

  ConfigDialog(KapitalistApp *app, QWidget *parent = 0);
  ~ConfigDialog();
  
protected slots:
 
  void slotApply();
  void slotOk();

protected:

  KapitalistApp *_app;

  QFrame *_themeFrm;
  QFrame *_appearanceFrm;

  ConfigTheme *_configTheme;
  ConfigAppearance *_configAppearance;

};

class ConfigTheme : public QWidget
{
  Q_OBJECT

public:

  ConfigTheme(KapitalistApp *app, QWidget *parent);
  ~ConfigTheme();

  void reset();

  void apply();

protected:

  KapitalistApp *_app;

  QBoxLayout *_top; 

  QListBox *_boardThm;
  QListBox *_namesThm;

  QDict<QString> _namesDict;
  QDict<QString> _boardDict;

//    QCheckBox *_atlcityChk;
//    QCheckBox *_germanChk;

};


class ConfigAppearance : public QWidget
{
  Q_OBJECT

public:

  ConfigAppearance(KapitalistApp *app, QWidget *parent);
  ~ConfigAppearance();

  void reset();
  void apply();

protected:

  KapitalistApp *_app;

  QBoxLayout *_top; 

};

#endif // CONFIGDIALOG_H





