// -*- C++ -*-

/***************************************************************************
                          connectdialog.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONNECTDIALOG_H
#define CONNECTDIALOG_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

//
// Qt
//

#include <qdialog.h>
#include <qlineedit.h>
#include <qbutton.h>

class QFrame;
class QLabel;
class QCheckBox;

//
// App
//
class KapitalistApp;

/**
 * TODO
 */
class ConnectDialog : public QDialog
{
  Q_OBJECT

public:

  ConnectDialog(KapitalistApp *app, QWidget *parent = 0, const char *name =0);
  ~ConnectDialog();
  
public slots:

  void name_entered()
    { hostnameLEdit->setFocus(); }
  void hostname_entered()
    { portLEdit->setFocus(); }
  void port_entered()
    { connectButton->setFocus(); }
  
  void slotConnect();
  void slotCancel();

protected:
  
  KapitalistApp *_app;

  QFrame *lineEditFrame;

  QLabel *nameLabel;
  QLabel *hostnameLabel;
  QLabel *portLabel;

  QLineEdit *nameLEdit;
  QLineEdit *hostnameLEdit;
  QLineEdit *portLEdit;
  QCheckBox *serverStartChkBox;

  QButton *connectButton;
  QButton *cancelButton;

};


#endif // CONNECTDIALOG_H
