// -*- C++ -*-
/***************************************************************************
                          monop.cpp  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// System
//

#include <stdlib.h>
#include <assert.h>

//
// Game
//
#include "kapgame.h"
#include "street.h"
#include "monop.h"
#include "player.h"


Monop::Monop(KapGame *game, Field *field[], 
	     struct packet_monop_init_info *minfo)
  : _game(game),
    _id(minfo->monopid),
    _nstreets(minfo->nstreets),
    _owner(NULL)
{
  int i, idx;

  assert(_game);

  for (i=0; i<_nstreets; ++i) {
    idx = minfo->street[i];
    assert(idx >= 0 || idx <= BOARD_N_FIELDS);
    _street[i] = dynamic_cast<Street*>(field[idx]);
    assert(_street[i]);
  }

  // set this Monop in the streets
  for (i=0; i<_nstreets; ++i)
    _street[i]->set_monop(this);
}

Monop::~Monop()
{
  // do nothing
}

void Monop::update(struct packet_monop_info *minfo)
{
  assert(_id == minfo->monopid);
  _owner = (_game->nobody(minfo->owner)) ? NULL : _game->player(minfo->owner);
}



