// -*- C++ -*-
/***************************************************************************
                          property.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef PROPERTY_H
#define PROPERTY_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//
// QT
//

#include <qobject.h>

//
// App
//

#include "global.h"

//
// Game
//

#include "field.h"


/**
 * TODO
 */
class Property : public Field {
  Q_OBJECT
  
public:

    // server constructor
//    Property(const int location, const int price);

    // client constructor
  Property(KapGame *game, struct packet_field_init_info *);

  virtual ~Property();

  Player * const owner() const 
    { return _owner; }
  const int price() const 
    { return _price; }

  const bool is_mortgaged() const 
    { return _is_mortgaged; }
  const bool is_owned() const
    { return (_owner) ? true : false; }
  const bool is_yours(Player *p) const
    { return (p == _owner) ? true : false; }

  virtual const int rent() const = 0;

    /**
     * client side
     */
  virtual void update(struct packet_field_info *);

protected:
  
  Player *_owner;
  int _price;
  bool _is_mortgaged;


};

#endif /* PROPERTY_H */
