// -*- C++ -*-
/***************************************************************************
                          street.cpp  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <assert.h>

#include "kapgame.h"
#include "street.h"
#include "player.h"
#include "monop.h"

//  extern Game *game;

Street::Street(KapGame *game, struct packet_field_init_info *sinfo)
  : Property(game, sinfo),
    _monop(NULL),
    _house_price(sinfo->house_price),
    _nhouses(0),
    _is_monop(false)
{
  _type = STREET;

  int i;

  for (i=0; i<STREET_N_RENT_CLASSES; ++i) {
    _rent[i] = sinfo->rent[i];
  }
}

Street::~Street()
{
}


void Street::update(struct packet_field_info *finfo)
{
  int s, a;

  assert(finfo->location == _location);

  s = statusflags = finfo->statusflags;
  a = actionflags = finfo->actionflags;

  _owner = (s & IS_OWNED)? _game->player(finfo->owner): NULL;
  _is_mortgaged = (s & IS_MORTGAGED)? true : false;

  _nhouses = finfo->nhouses;
  _is_monop = (statusflags & IS_MONOP)? true : false;

  emit updated();

}
