// -*- C++ -*-
/***************************************************************************
                          street.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef STREET_H
#define STREET_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//
// System
//

#include <assert.h>

//
// QT
//

#include <qobject.h>

//
// App
//

#include "global.h"

//
// Game
//

#include "property.h"

class Monop;
class Player;


/**
 * TODO
 */
class Street : public Property {
  Q_OBJECT

public:

    // server constructor
//    Street(const int location, 
//  	 const int price, const int house_price,
//  	 const int rent[]);

    // client constructor
  Street(KapGame *game, struct packet_field_init_info *);

  virtual ~Street();

  Monop * const monop() const 
    { return _monop; }
  const int nhouses() const 
    { return _nhouses; }
  const int house_price() const
    { return _house_price; }

  const int rent() const 
    { return ( (_is_monop && _nhouses==0) ? 2 * _rent[0] 
	       : _rent[_nhouses] ); }

  const int rent_for(int nh) const
    { 
      assert(nh>=0 && nh<STREET_N_RENT_CLASSES);
      return _rent[nh]; 
    }

  const  void set_monop(Monop *monop) 
    { _monop = monop; }

  // only use on server side!!
//    void set_is_monop(bool flag)
//      { _is_monop = flag; }





//    virtual void enter(Player *);
  
//    virtual void pay_rent(Player *);

//    virtual int buy(Player *);

//    virtual int mortgage(Player *);
//    virtual void unmortgage(Player *);

//    virtual int change_owner(Player *new_owner);

//    virtual int buy_houses(Player *, const int nhouses);
//    virtual int sell_houses(Player *, const int nhouses);

//    virtual void init_info_for(Player *player, struct packet_field_init_info *);
//    virtual void info_for(Player *player, struct packet_field_info *, int event);

  virtual void update(struct packet_field_info *);

signals:

  void updated();

protected:

  Monop *_monop;
  int _rent[STREET_N_RENT_CLASSES]; 
  int _house_price;

  int _nhouses;
  bool _is_monop;
  
};

#endif /* STREET_H */
