// -*- C++ -*-
/***************************************************************************
                          trade.cpp  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// App
//

#include "global.h"
#include "events.h"

//
// Game
//

#include "kapgame.h"
#include "trade.h"


Trade::Trade(KapGame *game, struct packet_trade *pack)
  : _game(game),
    _id(pack->tradeid),
    _srcplr(_game->player(pack->srcid)),
    _destplr(_game->player(pack->destid)),
    _finishedflag(pack->state)
{
  int i;

  assert(_game);

  switch (pack->offer_from) {

  case T_SRC:

    _srcmoney = pack->money;
    _destmoney = 0;
    for (i=0; i<BOARD_N_FIELDS; ++i) {
      _srcprop[i] = pack->prop[i];
      _destprop[i] = T_NOTRADE;
    }
    break;

  case T_DEST:

    _srcmoney = 0;
    _destmoney = pack->money;
    for (i=0; i<BOARD_N_FIELDS; ++i) {
      _srcprop[i] = T_NOTRADE;
      _destprop[i] = pack->prop[i];
    }
    break;

  default:
    assert(0);	// bug
    break;
  }
}


void Trade::update(struct packet_trade *pack)
{
  int i;
  assert(pack);

  _id = pack->tradeid;
  _srcplr = _game->player(pack->srcid);
  _destplr = _game->player(pack->destid);

  switch (pack->offer_from) {

  case T_SRC:

    _srcmoney = pack->money;
    for (i=0; i<BOARD_N_FIELDS; ++i)
      _srcprop[i] = pack->prop[i];
    break;

  case T_DEST:

    _destmoney = pack->money;
    for (i=0; i<BOARD_N_FIELDS; ++i)
      _destprop[i] = pack->prop[i];
    break;

  default:
    assert(0);	// bug
    break;
  }

  _finishedflag = pack->state;

}

