// -*- C++ -*-
/***************************************************************************
                          trade.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef TRADE_H
#define TRADE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//
// System
//

#include <stdio.h>

//
// Game
//

#include "player.h"

class KapGame;


enum {
  T_NOTRADE=0,
  T_SRC,
  T_DEST
};

enum {
  T_NOT_FINISHED = 0,
  T_SRC_REJECTED,
  T_DEST_REJECTED,
  T_SRC_AGREED,
  T_DEST_AGREED,
  T_PROCEEDED
};


/**
 * TODO
 */
class Trade {
  
public:
  
  Trade(KapGame *game, struct packet_trade *);

  Player * const get_src() const
    { return _srcplr; }
  Player * const get_dest() const
    { return _destplr; }

  const bool is_finished() const
    { return (_finishedflag != T_NOT_FINISHED); }

  void update(struct packet_trade *);

  const int id() const { return _id; }

protected:
  
  KapGame *_game;

  int _id;
  Player *_srcplr;
  Player *_destplr;
  
  int _srcmoney;
  int _destmoney;
  int _srcprop[BOARD_N_FIELDS];
  int _destprop[BOARD_N_FIELDS];

  int _finishedflag;

protected:
  
  const char *srcplrname() { return _srcplr->name(); }
  const char *destplrname() { return _destplr->name(); }

  bool src_gives(int *prop, int i) { return (prop[i] == T_SRC); }
  bool dest_gives(int *prop, int i) { return (prop[i] == T_DEST); }


};

#endif /* TRADE_H */
