// -*- C++ -*-

/***************************************************************************
                          cardview.cpp  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/**
 * Note: This class is more or less obsolete since the cards are shown
 * by the GameInfo canvas itself without using the CardView class
 */

//
// System
//

#include <assert.h>

//
// Game
//

#include "field.h"

//
// View
//

#include "kapview.h"
#include "cardview.h"


const QColor chanceColor = QColor(200,255,250);	//light blue
const QColor cchestColor = QColor(255,240,221); //baby face color

CardView::CardView(KapView *view, QWidget *parent)
    : QLabel(parent), _view(view)
{
  setText("first line\nsecond line\nthird line");
  setAlignment(AlignCenter);
  setFrameStyle( Box | Sunken );
  setFixedSize( QSize(250,120) );
  hide();
}

CardView::~CardView()
{
}


void CardView::draw_card( const int type, const int card_no )
{
  switch (type) {
  case COMCHEST:
    setBackgroundColor(cchestColor);
    setText(_view->replace_locales(_view->cchest_card_locale(card_no).msg));
    break;
  case CHANCE:
    setBackgroundColor(chanceColor);
    setText(_view->replace_locales(_view->chance_card_locale(card_no).msg));
    break;
  default:
    assert(0);
  }
  show();
}
