// -*- C++ -*-

/***************************************************************************
                          centerview.cpp  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// Qt
//

#include <qframe.h>
#include <qpixmap.h>
#include <qlabel.h>

//
// View
//

#include "kapview.h"
#include "centerview.h"
#include "fieldview.h"


CenterView::CenterView(KapView *view, QWidget *parent)
  : QFrame(parent), _view(view)
{
  setFrameStyle( QFrame::Panel | QFrame::Sunken);
  setLineWidth(4);
  setMidLineWidth(3);
  setPalette( QPalette(_view->centerColor()) );
//    setBackgroundColor(_view->centerColor());
  _logo = new QLabel(this);
  _logo->setAlignment(AlignCenter);
  _logo->setBackgroundColor(_view->centerColor());
  _logo->setPixmap(_view->getPixmap("logo"));
//    _logo->setMinimumSize( _logo->sizeHint() );
  _logoAlign = AlignCenter;
  _logo->show();

  adjustSize();
  show();
}

CenterView::~CenterView()
{
}

//  QSize CenterView::sizeHint() const
//  {
//  //    int w;
//  //    w = 9 * FieldView::DEFAULT_WIDTH;
//  //    return QSize(w, w);
//    return QSize(380,380);
//  }

void CenterView::resizeEvent( QResizeEvent * )
{
  adjustLogo();
}

void CenterView::set_logo_alignment( int alignment )
{
  _logoAlign = alignment;
  adjustLogo();
}

void CenterView::adjustLogo()
{
  QRect r;

  // put logo at right position
  if (_logoAlign & AlignTop) {
    r.setSize(_logo->sizeHint());
    r.moveCenter( QPoint(width()/2, _logo->height()/2 +20) );
  } else {	// all other cases
    r.setSize(_logo->sizeHint());
    r.moveCenter( QPoint(width()/2, height()/2-20) );
  }
  _logo->setGeometry(r);
  _logo->hide();
}
