// -*- C++ -*-

/***************************************************************************
                          diceview.cpp  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// System
//

#include <stdlib.h>
#include <assert.h>
#include <time.h>

//
// Qt
//

#include <qwidget.h>
#include <qpixmap.h>
#include <qlabel.h>
//  #include <qlayout.h>

//
// Game
//

#include "kapgame.h"


//
// View
//

#include "kapview.h"
#include "diceview.h"


DiceView::DiceView(KapView *view, QWidget *diceParent)
  : _view(view), _diceParent(diceParent)
{
  int i,j;

  for(i=0; i<6; ++i) {
    for (j=0; j<4; ++j) {
      _die[i][j] = _view->getDiePixmap(i,j);
    }
  }

  _mask = _view->getBitmap("die-mask");

  _die1 = new QLabel(_diceParent);
  _die1->setBackgroundColor(_view->centerColor());
  _die1->setAlignment(AlignCenter);
  _die1->setPixmap(_die[0][0]);
  _die1->setMask(_mask);

  _die1->setFixedSize(_die[0][0].size());
//    _die1->show();

  _die2 = new QLabel(_diceParent);
  _die1->setBackgroundColor(_view->centerColor());
  _die2->setAlignment(AlignCenter);
  _die2->setPixmap(_die[0][0]);
  _die2->setMask(_mask);

  _die2->setFixedSize(_die[0][0].size());
//    _die2->show();

  // show the dice with random orientation
  srand(time(NULL));
}

DiceView::~DiceView()
{
}

void DiceView::init_dice()
{
//    _top = new QGridLayout(this,5,5);

//    _top->addWidget(_die1, 1,1);
//    _top->addWidget(_die2, 2,2);

//    _top->activate();
//    show();
  _die1->move(_die1->mapToParent(QPoint(0,0)) + QPoint(10,30));
  _die1->show();
  _die2->move(_die2->mapToParent(QPoint(0,0)) + QPoint(15,35+_die2->height()));
  _die2->show();

}  

void DiceView::set_dice(const int die1, const int die2)
{
  int i,j;

  assert(die1>=1 && die1<=6);
  assert(die2>=1 && die2<=6);


  i = (int) (4.0 * rand()/(RAND_MAX + 1.0));
  j = (int) (4.0 * rand()/(RAND_MAX + 1.0));

  _die1->setPixmap(_die[die1-1][i]);
  _die2->setPixmap(_die[die2-1][j]);
  _die1->show();
  _die2->show();
}


void DiceView::update()
{
  int die1 = _view->getGame()->die1();
  int die2 = _view->getGame()->die2();

  set_dice(die1, die2);
}
