// -*- C++ -*-

/***************************************************************************
                          dieview.h  -  description
                             -------------------
    begin                : Mon Jun 11 23:26:26 CEST 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIEVIEW_H
#define DIEVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

//
// Qt
//

#include <qcanvas.h>

//
// View
//

class GameInfo;

/**
 * TODO
 */
class DieView : public QCanvasSprite {

public:

  DieView(KapView *view, QCanvas *canvas, GameInfo *gameinfo);
  virtual ~DieView();

//    void set_die(const int value);

  /**
   * returns false it a transparent pixel on the image is hit, otherwise true.
   */
  bool hit( const QPoint &p ) const;

  /**
   * moves die, reflection on borders of canvas, damping of velocity
   */
  void advance( int phase );

  void setValue( int val ) { if (val >= 1 && val <= 6)  _value = val; }

  void update();

protected:

  KapView *_view;
  QCanvas *_canvas;
  GameInfo *_gameinfo;

  int _value;
  bool _moveX, _moveY;
  double _airResistance;
  double _bumpResistance;

  int _nframes;
  /**
   * includes number of frames in 0th field and frame indices for values 1 to 6
   */
  int _frameIndex[7];
};

  
#endif // DIEVIEW_H
