// -*- C++ -*-

/***************************************************************************
                          gameinfo.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GAMEINFO_H
#define GAMEINFO_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

//
// Qt
//

#include <qcanvas.h>
#include <qpoint.h>
#include <qpixmap.h>
#include <qcolor.h>

//
// View
//

class KapView;
class DieView;
class CardView;


/**
 * TODO
 */
class GameInfo : public QCanvasView {
  Q_OBJECT

public:

  GameInfo(KapView *view, QCanvas *canvas, QWidget *parent);
  virtual ~GameInfo();

  void message(int msg_type, const char *headline, const char *details);

  void set_headline(const char *);
  void set_details(int msg_type, const char *details);

  void append_details(const char *details);

  void set_dice(const int die1, const int die2);
  /**
   *  called by the dice when finished movement
   */
  void die_stopped(const DieView *die); 

  void draw_card( const int type, const int card_no );
  void hide_card();

protected:

  KapView *_view;
  QCanvas *_canvas;

  const QColor _infoColor;

  QCanvasRectangle *_headlineBg;
  QCanvasRectangle *_headlineShadow;
  QCanvasRectangle *_detailsBg;
  QCanvasRectangle *_detailsShadow;
  QCanvasText *_headline;
  QCanvasText *_details;
  
  DieView *_die1;
  DieView *_die2;
  QCanvasRectangle *_cardBg;
  QCanvasRectangle *_cardShadow;
  QCanvasText *_cardText;
  
  bool _die1_moving;
  bool _die2_moving;

//    QPixmap _infoPixmap;
//    QPixmap _cmdPixmap;
//    QPixmap _queryPixmap;
//    QLabel *_headline;
//    QLabel *_iconLab;
//    QLabel *_details;

protected:

  void resizeEvent( QResizeEvent *);

  void set_icon(int msg_type);

};

#endif // GAMEINFO_H

