// -*- C++ -*-
/***************************************************************************
                          housesdialog.h  -  description
                             -------------------
    begin                : Mon Jul 15 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef HOUSESDIALOG_H
#define HOUSESDIALOG_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

//
// Qt / KDE
//

#include <kdialogbase.h>

class QLabel;
class QSlider;
class QGridLayout;

//
// Game
//

#include "monop.h"

class KapitalistApp;

/**
 * TODO
 */
class HousesDialog : public KDialogBase
{
  Q_OBJECT

public:

  HousesDialog(KapitalistApp *app, QWidget *parent, int monopid);
  ~HousesDialog();

  void update_status(int row=-1);
  void update_houseviews(int row=-1);
  void update_money(int row=-1);

protected:
  
  KapitalistApp *_app;

  Monop *_monop;
  int _nhouses;
  int _newhouses[MAX_STREETS_IN_MONOP];

  int _money[MAX_STREETS_IN_MONOP];
  int _moneySum;

  QGridLayout *_top;
  QGridLayout *_housesRow[MAX_STREETS_IN_MONOP];

  QLabel *_streetLab[MAX_STREETS_IN_MONOP];

  QPixmap _pmHouse;
  QPixmap _pmHotel;
  QPixmap _pmHouseAdd;
  QPixmap _pmHotelAdd;
  QPixmap _pmHouseDel;
  QPixmap _pmHotelDel;

  QLabel *_house[MAX_STREETS_IN_MONOP][STREET_MAX_HOUSES+1];
  QLabel *_houseadd[MAX_STREETS_IN_MONOP][STREET_MAX_HOUSES+1];
  QLabel *_housedel[MAX_STREETS_IN_MONOP][STREET_MAX_HOUSES+1];
  QLabel *_hotel[MAX_STREETS_IN_MONOP];
  QLabel *_hoteladd[MAX_STREETS_IN_MONOP];
  QLabel *_hoteldel[MAX_STREETS_IN_MONOP];

  QSlider *_nHousesSlider[MAX_STREETS_IN_MONOP];
//    QSlider *_dec[MAX_STREETS_IN_MONOP];
  
  QLabel *_moneyLab[MAX_STREETS_IN_MONOP];
  QLabel *_moneySumDesc;
  QLabel *_moneySumLab;

protected slots:

  void slotApply();
  void slotReset();
  void slotClose();

  void slotNumHouses0(int nhouses);
  void slotNumHouses1(int nhouses);
  void slotNumHouses2(int nhouses);
  void slotNumHouses3(int nhouses);
  void slotNumHouses4(int nhouses);

  void slotNumHouses(int row, int nhouses);

};


#endif // HOUSESDIALOG_H
