// -*- C++ -*-
/***************************************************************************
                          jaildialog.cpp  -  description
                             -------------------
    begin                : Mon Jul  9 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// Qt
//

#include <kdialogbase.h>
#include <klocale.h>
#include <qlayout.h>
#include <qvbox.h>
#include <qlabel.h>
//
// App
//

#include "kapitalist.h"
#include "global.h"

#include "jaildialog.h"

//
// View
//

#include "kapview.h"


/**
 *
 */
//  UrlDlg::UrlDlg( QWidget *parent, const QString& caption,
//                   const QString& urltext)
//     : KDialogBase( parent, "urldialog", true, caption, Ok|Cancel, Ok, true )
//   {
//     QWidget *page = new QWidget( this ); 
//     setMainWidget(page);
//     QVBoxLayout *topLayout = new QVBoxLayout( page, 0, spacingHint() );
 
//     QLabel *label = new QLabel( caption, page, "caption" );
//     topLayout->addWidget( label );
 
//     lineedit = new QLineEdit( urltext, page, "lineedit" );
//     lineedit->setMinimumWidth(fontMetrics().maxWidth()*20);
//     topLayout->addWidget( lineedit );

//     topLayout->addStretch(10); 
//   }


JailDialog::JailDialog(KapitalistApp *app, QWidget *parent)
  : KDialogBase(parent, "jaildialog", true, "Leave Jail", User1|User2|Cancel, 
		Cancel, true, 
		QString(i18n("Use Card")), QString(i18n("Pay Fine")) ),
//    : KDialogBase( IconList, "Leave Jail", User1|User2|Cancel, 
//    		 Cancel, parent, "jaildialog", true, true, 
//    		 QString(i18n("Pay Fine")), QString(i18n("Use Card")) ),
    _app(app)
{
  QWidget *page = new QWidget( this ); 
  setMainWidget(page);
  QVBoxLayout *topLayout = new QVBoxLayout( page, 0, spacingHint() );
 
  // TODO: KDE classref: margins should not be explicitly added
  topLayout->addSpacing(spacingHint()); 

  QLabel *pic = new QLabel( page );
  QPixmap jailPix = _app->view()->getPixmap("jail");
  pic->setPixmap(jailPix);
//    pic->setMinimumSize( jailPix.size() );
  pic->setAlignment(AlignCenter);
  topLayout->addWidget( pic );
		 
  QLabel *label = new QLabel( "You can leave jail by either paying a fine\n"
			      "or using a jail card. What do you prefer?",
			      page, "jdlab" );
  label->setAlignment(AlignCenter);
  topLayout->addWidget( label );
 
  topLayout->addStretch(10); 

  topLayout->activate();
//    QVBox *page = addVBoxPage( QString::null, //i18n("itemName: You can leave Jail!!"),
//  			     i18n("header: Hi")
//  //  			     _app->view()->getPixmap("rrtop") );
//  			      );
//    QLabel *label = new QLabel( i18n("Label inside page"), page );
//    addPage( i18n("Leave jail"), i18n("You can leave jail") );

  QObject::connect(this, SIGNAL(user1Clicked()), this, SLOT(slotJailPay()));
  QObject::connect(this, SIGNAL(user2Clicked()), this, SLOT(slotJailCard()));
}

JailDialog::~JailDialog()
{
}

void JailDialog::slotJailPay()
{
  emit accept();
}

void JailDialog::slotJailCard()
{
  emit accept();
}
