// -*- C++ -*-

/***************************************************************************
                          jailfieldview.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef JAILFIELDVIEW_H
#define JAILFIELDVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

//
// Qt
//

#include <qstring.h>
#include <qpoint.h>

class QBoxLayout;
class QLabel;

//
// View
//

#include "fieldview.h"

class KapView;
class PlayerView;


/**
 * TODO
 */
class JailFieldView : public FieldView {
  Q_OBJECT

public:

  JailFieldView(KapView *view, QWidget *parent, const int orientation,
		const Field *);
  virtual ~JailFieldView();

  virtual void resizeEvent( QResizeEvent *);

//    virtual void set_title(const char *);
  void set_jail_title(const char *);
  virtual void change_icon(const int fieldID=-1);

  virtual void add_all_widgets();
  virtual void activate_layouts();

  virtual void init_plr_positions();

//    virtual void update_status();

  virtual void enter(PlayerView *);
  virtual void leave(PlayerView *);

protected:

  // _jail is placed above the JUST_VISITING title and contains jail frame
  QBoxLayout *_jail;

  QString _jailTitle;
  QLabel *_jailLab;

  QPoint _jailPlrPos[GAME_MAX_PLAYERS];	// additional Positions for jail
  PlayerView *_jailPlr[GAME_MAX_PLAYERS];	// register of plrs in jail
  
};

#endif // JAILFIELDVIEW_H




