// -*- C++ -*-

/***************************************************************************
                          outputwindow.cpp  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// System
//

#include <assert.h>

//
// Qt
//

#include <qtextedit.h>

//
// App
//

#include "global.h"

//
// View
//

#include "outputwindow.h"
#include "kapview.h"
#include "themedata.h"

OutputWindow::OutputWindow(KapView *view, QWidget *parent, int mode)
  : QTextEdit(parent), 
    _view(view),
    _mode(mode)
{
  setReadOnly(true);
//    setFont(QFont("fixed", 10));
  // minimum 8 lines
//    setMinimumHeight( fontMetrics().height() * 8 );
//    setMaximumHeight( fontMetrics().height() * 20 );
  connect(this, SIGNAL(textChanged()),
	  this, SLOT(go_to_end()));

  show();
}

OutputWindow::~OutputWindow()
{
  emit returnPressed();
}


void OutputWindow::go_to_end()
{
  setCursorPosition(paragraphs(),0);
}

void OutputWindow::slotChangeMode(int newmode)
{
  if (newmode < 0 || newmode >= LAST_MODE) return;

  int oldmode = _mode;
  _mode = newmode;

  if (oldmode == newmode) return;  // nothing to be done

}
