// -*- C++ -*-

/***************************************************************************
                          playerview.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLAYERVIEW_H
#define PLAYERVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

//
// Qt
//

#include <qlabel.h>
#include <qcolor.h>
#include <qnamespace.h>
#include <qtimer.h>

//
// Game
//

#include "player.h"

class Player;

//
// View
//

class KapView;


const QColor token_color[GAME_MAX_PLAYERS] =
{
  Qt::red, QColor(0,200,0), Qt::blue, Qt::yellow, Qt::cyan, Qt::magenta, 
  Qt::gray, Qt::white

  // possibilities
//  black, white, darkGray, gray,
//  lightGray, red, green, blue, cyan, magenta, yellow, darkRed,
//  darkGreen, darkBlue, darkCyan, darkMagenta, darkYellow,

};



/**
 * TODO
 */
class PlayerView : public QLabel {
  Q_OBJECT

public:
  enum {
    SLOW_SPEED = 600,
    MEDIUM_SPEED = 400,
    FAST_SPEED = 200
  };

public:

  PlayerView(KapView *view, QWidget *parent, Player *);
  virtual ~PlayerView();

  const int id() const
    { return _plr->id(); }

  const int location() const
    { return _plr->location(); }

  const int old_loc() const
    { return _curr_loc; }

  QColor tokenColor() const
    { return _tokenColor; }

  QLabel *get_token(QWidget *use_parent);

  static QLabel *get_default_token(KapView *use_view,
				   QWidget *use_parent);

  void update_status(int event);

  void move_to(const int new_loc, const int direction = DIRECTION_FORWARD);

//    void enableAnimation(const bool anim);

protected:

  enum { DIRECTION_FORWARD, DIRECTION_BACKWARD };

  KapView *_view;

  Player *_plr;
  
  QColor _tokenColor;
  int _curr_loc;
  int _curr_target;

  int _time_moveOneStep;
  bool _moveTimerActive;
  bool _animationEnabled;
  int _movingDirection;

  QTimer _moveTimer;

protected:

  void moveOneStep();
  void moveDirectly(const int src_loc, const int dest_loc);

protected slots:

  void slotMoveOn();

};

#endif // PLAYERVIEW_H




