// -*- C++ -*-

/***************************************************************************
                          propertyview.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PROPERTYVIEW_H
#define PROPERTYVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

//
// Qt / KDE
//

#include <qstring.h>

class QLabel;
class QFrame;
class QBoxLayout;
class QGridLayout;

class KPopupMenu;

//
// App
//

#include "global.h"

class Property;

//
// View
//

#include "fieldview.h"
#include "deed.h"

class KapView;
class PropertyDeed;


/**
 * TODO
 */
class PropertyView : public FieldView {
  Q_OBJECT

public:

  PropertyView(KapView *view, QWidget *parent, const int orientation,
		const Property *, bool add_base_widgets = true);
  virtual ~PropertyView();

//    virtual void resizeEvent( QResizeEvent *);
  
  QColor color() const { return _color; }
  const Property *property() const { return _prop; }

  // TODO: should be protected
protected:
  virtual void setup_price(const int);

public:
  virtual void change_price(const int);

  virtual void add_all_widgets();
  virtual void activate_layouts();

  virtual void init_plr_positions();

  virtual void update_status();

  virtual void resize_elements();
  virtual void resize_price();

  virtual void rereadThemeData();

  virtual PropertyDeed *getDeed(KapitalistApp *, QWidget *parent,
				const int variant = Deed::ELABORATE) const;

public slots:

  virtual void slotInfoAbout();
  virtual void slotBuy();
  virtual void slotMortgage();
  virtual void slotUnmortgage();

  virtual void updatePopupMenu();

protected:
  
  enum {
    POPUPID_INFO,
    POPUPID_BUY,
    POPUPID_MORTGAGE,
    POPUPID_UNMORTGAGE,
    POPUPID_HOUSES,
    POPUPID_HOUSES_SELL
  };

  const Property *_prop;	// data base

  int _sideWidth;
  int _sideHeight;

  QColor _color;

  QString _price;

  QLabel *_priceLab;

  QBoxLayout *_main;	// title and price
  QFrame *_sideFrm;	// color, houses, owned, ...
  QGridLayout *_side;	// the layout for sideFrm

  QFrame *_ownedSign;
  QLabel *_mortgSign;

  KPopupMenu *_popup;

protected:

  bool eventFilter( QObject *, QEvent * );
  void mousePressEvent( QMouseEvent * );

};    


#endif // PROPERTYVIEW_H



