// -*- C++ -*-
/***************************************************************************
                          propinfodialog.cpp  -  description
                             -------------------
    begin                : Mon Jul  9 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// System

#include <assert.h>
#include <math.h>

//
// Qt
//

#include <kdialogbase.h>
#include <klocale.h>
#include <qvbox.h>
#include <qlayout.h>
#include <qlabel.h>

//
// App
//

#include "kapitalist.h"
#include "global.h"

#include "propinfodialog.h"

//
// Game
//

#include "kapgame.h"
#include "property.h"

//
// View
//

#include "kapview.h"
#include "propertyview.h"
#include "propertydeed.h"

/**
 *
 */
//  UrlDlg::UrlDlg( QWidget *parent, const QString& caption,
//                   const QString& urltext)
//     : KDialogBase( parent, "urldialog", true, caption, Ok|Cancel, Ok, true )
//   {
//     QWidget *page = new QWidget( this ); 
//     setMainWidget(page);
//     QVBoxLayout *topLayout = new QVBoxLayout( page, 0, spacingHint() );
 
//     QLabel *label = new QLabel( caption, page, "caption" );
//     topLayout->addWidget( label );
 
//     lineedit = new QLineEdit( urltext, page, "lineedit" );
//     lineedit->setMinimumWidth(fontMetrics().maxWidth()*20);
//     topLayout->addWidget( lineedit );

//     topLayout->addStretch(10); 
//   }


PropInfoDialog::PropInfoDialog(KapitalistApp *app, QWidget *parent,
			       const PropertyView *propview)
  : KDialogBase( Tabbed, "Property Info", Close, Close,
		 parent, "propinfodialog", false, true ),
    _app(app), _propview(propview)
{
  QVBox *page = addVBoxPage( i18n("Title Deed") );
  page->setMargin( spacingHint() );

//    StreetView *streetview = dynamic_cast<StreetView *> propview;

//    if (streetview) {
//      _deed = new StreetDeed(_app, page, streetview, Deed::ELABORATE);
//    } else {
//      _deed = new PropertyDeed(_app, page, _propview, Deed::ELABORATE);
//    }

  _deed = _propview->getDeed(_app, page, Deed::ELABORATE);

  _deed->show();
  setFixedSize(sizeHint());
}

PropInfoDialog::~PropInfoDialog()
{
}



void PropInfoDialog::slotClose()
{
  // TODO: reset to actual situation
  emit reject();
  delayedDestruct();
}

