// -*- C++ -*-
/***************************************************************************
                          railroaddeed.cpp  -  description
                             -------------------
    begin                : Mon Jul 13 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// System
//

#include <assert.h>

//
// Qt
//

#include <qlayout.h>
#include <qlabel.h>

//
// App
//

#include "kapitalist.h"

//
// Game
//

#include "railroad.h"

//
// View
//

#include "kapview.h"
#include "fieldview.h"
#include "propertyview.h"

#include "railroaddeed.h"

/**
 *
 */
RailroadDeed::RailroadDeed(KapitalistApp *app, QWidget *parent, 
			   const PropertyView *propview, int variant)
  : PropertyDeed(app, parent, propview, variant)
{
  QString front;
  QString text;
  int i;
  int nrows = BOARD_N_RAILROADS + 1;
  int nspacing = 3;

  const Railroad *railroad 
    = dynamic_cast<const Railroad *>(_propview->property());

  assert(railroad);

  switch(_variant) {
  case NORMAL: 
    // everything done in PropertyDeed constructor
    break;

  case ELABORATE:

    _headFrm->setFrameStyle( NoFrame);
    //    _headFrm->setLineWidth(0);
    _detailsFrm->setFrameStyle( NoFrame );
    //    _detailsFrm->setLineWidth(0);

    _details = new QGridLayout(_detailsFrm, nrows+nspacing+2,9);

    _details->addColSpacing(0,10);
    _details->addColSpacing(2,10);
    _details->addColSpacing(4,10);
    _details->addColSpacing(6,10);
    _details->addRowSpacing(0,10);
    _details->setRowStretch(nrows+nspacing+1,1);

    _details->addWidget(new QLabel(_detailsFrm), 0,0, AlignLeft);
    // TODO: 
    for (i=1; i<=BOARD_N_RAILROADS; ++i) {
      if (i==1) front = "RENT:";
      else front = "";
      text = ( QString().setNum(i) + QString(" railroad") 
	       + ( (i>1) ? QString("s") : QString::null ) );
      
      addLine(i, front, text, railroad->rent_for(i));
    }
    _details->addRowSpacing(i++,20);
    addLine(i++, "MORTGAGE", "value", railroad->price() / 2);
    _details->addRowSpacing(i++,20);

    _details->activate();

    _top->activate();
     setMinimumSize(sizeHint());
    break;

  default:
    assert(0);
  }
}


RailroadDeed::~RailroadDeed()
{
}

//  void RailroadDeed::updateStatus()
//  {
//  }

