// -*- C++ -*-

/***************************************************************************
                          streetview.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STREETVIEW_H
#define STREETVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

//
// Qt
//

#include <qbitmap.h>
#include <qpixmap.h>
#include <qcolor.h>

class QLabel;

//
// App
//

#include "global.h"

class Street;

//
// View
//

#include "propertyview.h"

class KapView;


/**
 * TODO
 */
class StreetView : public PropertyView {
  Q_OBJECT

public:
  StreetView (KapView *view, QWidget *parent, int orientation,
	      const Street *);
  virtual ~StreetView();

  QColor color() const { return _color; }
  const Street *street() const { return _street; }

  virtual void add_all_widgets();
  virtual void activate_layouts();

  virtual void update_status();

  virtual PropertyDeed *getDeed(KapitalistApp *, QWidget *parent,
				const int variant) const;
public slots:

  void slotHouses();
//    void slotSellHouses();

  virtual void updatePopupMenu();

protected:
  
  QBitmap _bithouse;
  QPixmap _pixhouse;
  QBitmap _bithotel;
  QPixmap _pixhotel;

  const Street *_street;	// data base

  QLabel *_house[STREET_MAX_HOUSES];
  QLabel *_hotel;

};    


#endif // STREETVIEW_H



