// -*- C++ -*-
/***************************************************************************
                          tradedialog.cpp  -  description
                             -------------------
    begin                : Mon Jul  9 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// TODO: remove this
//  #include <iostream.h>

//
// Qt
//

#include <kdialogbase.h>
#include <klocale.h>
#include <knuminput.h>

#include <qlayout.h>
#include <qvbox.h>
#include <qlabel.h>
#include <qlineedit.h>

//
// App
//

#include "kapitalist.h"
#include "global.h"
#include "events.h"

//
// Game
//

#include "kapgame.h"
#include "property.h"

//
// View
//

#include "kapview.h"
#include "kapitalist.h"
#include "propertydeed.h"

#include "tradedialog.h"
#include "tradeview.h"


/**
 *
 */
TradeDialog::TradeDialog(KapitalistApp *app, QWidget *parent)
  : KDialogBase( Tabbed, "Trades", Close, (KDialogBase::ButtonCode)0,
		 parent, "tradedialog", false, true ),
    _app(app)
{
  int i;

  for (i=0; i<app->game()->nplayers(); ++i) {

    if (i == _app->game()->myPID()) { // skip myself
      _outerPage[i] = 0;
      _pageIndex[i] = -1;
      _page[i] = 0;
      continue;
    }

    _outerPage[i] = addVBoxPage( QString(_app->game()->player(i)->name()) ); 
    _pageIndex[i] = pageIndex(_outerPage[i]);

    _page[i] = new TradeView( _app, _outerPage[i], _app->game()->player(i));
//      _outerPage[i]->addWidget(_page[i]);

  }
//    QObject::connect( this, SIGNAL(user1Clicked()),
//  		    this, SLOT(slotReject()) );
//    QObject::connect( this, SIGNAL(user2Clicked()),
//  		    this, SLOT(slotAccept()) );
//    QObject::connect( this, SIGNAL(user3Clicked()), 
//  		    this, SLOT(slotOffer()) );

}


TradeDialog::~TradeDialog()
{
//    cout << "TradeDialog destructed" << endl;
}

//  void TradeDialog::slotNewTrade()
//  {
//  }

//  void TradeDialog::slotOffer()
//  {
//    int i;

//    cout << "slotOffer()" << endl;

//    for (i=0; i<_app->game()->nplayers(); ++i) {
//      cout << _pageIndex[i] << ":" << activePageIndex() << endl;
//      if (_pageIndex[i] == activePageIndex()) {
//        cout << "...page " << i << endl;
//        _page[i]->slotOffer();
//        break;
//      }
//    }
  
//  }


//  void TradeDialog::slotAccept()
//  {
//    int i;

//    cout << "slotAccept()" << endl;
//    for (i=0; i<_app->game()->nplayers(); ++i) {
//      if (_pageIndex[i] == activePageIndex()) {
//        cout << "...page " << i << endl;
//        _page[i]->slotAccept();
//        break;
//      }
//    }
//  }

//  void TradeDialog::slotReject()
//  {
//    int i;

//    cout << "slotReject()" << endl;
//    for (i=0; i<_app->game()->nplayers(); ++i) {
//      if (_pageIndex[i] == activePageIndex()) {
//        cout << "...page " << i << endl;
//        _page[i]->slotReject();
//        break;
//      }
//    }
//  }

void TradeDialog::slotClose()
{
//    cout << "slotClose()" << endl;
  emit reject();  // not to confuse with reject trade !!!
//    delayedDestruct();
}

void TradeDialog::update(struct packet_trade *pack)
{
//    int event = pack->event;
  int myPID = _app->game()->myPID();

  if (pack->srcid != myPID && pack->destid != myPID) { // I'm not involved
    return;
  }

  int otherPID = ( (pack->srcid == myPID) ? pack->destid : pack->srcid );

  _page[otherPID]->update(pack);
}

void TradeDialog::updateHoldings()
{
  int i;
  for (i=0; i<_app->game()->nplayers(); ++i) {
    if (i == _app->game()->myPID()) continue; // skip myself
    _page[i]->updateMyHoldings();
    _page[i]->updateYourHoldings();
  }
}

//  void TradeDialog::slotChangeButtons(int flag)
//  {
//    if (flag & T_BUT_AGREE) enableButton(User2, true);
//    else enableButton(User2, false);
//    if (flag & T_BUT_REJECT) enableButton(User1, true);
//    else enableButton(User1, false);
//    if (flag & (T_BUT_OFFER | T_BUT_REPLY)) enableButton(User3, true);
//    else enableButton(User3, false);
//  }



//  void TradeDialog::slotAddProperty(int propid)
//  {
//  }

//  void TradeDialog::slotAddMoney(int money)
//  {
//  }

//  void TradeDialog::slotAddJailCard()
//  {
//  }

