// -*- C++ -*-
/***************************************************************************
                          utilitydeed.cpp  -  description
                             -------------------
    begin                : Mon Jul 13 2001
    copyright            : (C) 2001 by Daniel Hermann
    email                : Daniel.Hermann@stud.uni-karlsruhe.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// System
//

#include <cassert>

//
// Qt
//

#include <qlayout.h>
#include <qlabel.h>

//
// App
//

#include "kapitalist.h"

//
// Game
//

#include "utility.h"

//
// View
//

#include "kapview.h"
#include "fieldview.h"
#include "propertyview.h"

#include "utilitydeed.h"

/**
 *
 */
UtilityDeed::UtilityDeed(KapitalistApp *app, QWidget *parent, 
			   const PropertyView *propview, int variant)
  : PropertyDeed(app, parent, propview, variant)
{
  QString front;
  QString text;
  QString rent;

  int i;
  int nrows = BOARD_N_UTILS;
  int nspacing = 3;

  const Utility *utility 
    = dynamic_cast<const Utility *>(_propview->property());

  assert(utility);

  switch(_variant) {
  case NORMAL: 
    // everything done in PropertyDeed constructor
    break;

  case ELABORATE:

    _headFrm->setFrameStyle( NoFrame);
    //    _headFrm->setLineWidth(0);
    _detailsFrm->setFrameStyle( NoFrame );
    //    _detailsFrm->setLineWidth(0);

    _details = new QGridLayout(_detailsFrm, nrows+nspacing+2,9);

    _details->addColSpacing(0,10);
    _details->addColSpacing(2,10);
    _details->addColSpacing(4,10);
    _details->addColSpacing(6,10);
    _details->addRowSpacing(0,10);
    _details->setRowStretch(nrows+nspacing+1,1);

    _details->addWidget(new QLabel(_detailsFrm), 0,0, AlignLeft);

    // TODO: 
    for (i=1; i<=BOARD_N_UTILS; ++i) {
      if (i==1) front = "RENT:";
      else front = "";
      text = ( QString().setNum(i) + QString(" utilit") 
	       + ( (i>1) ? QString("ies") : QString("y") ) );
      rent = ( QString("$") 
	       + QString().setNum(utility->rent_factor(i-1))
	       + QString(" * dice") );
      addLine(i, front, text, rent);
    }
    _details->addRowSpacing(i++,20);
    addLine(i++, "MORTGAGE", "value", utility->price() / 2);
    _details->addRowSpacing(i++,20);
//      cout << "iend = " << i << endl;

    _details->activate();

    _top->activate();
    setMinimumSize(sizeHint());
    break;

  default:
    assert(0);
  }
}


UtilityDeed::~UtilityDeed()
{
}

//  void UtilityDeed::updateStatus()
//  {
//  }

